clear;
n=100;
N=1000;
p=0.2;

medi=[];
mea=[];
midhinge=[];
iqm=[];
for i=1:N
    x=zeros(n,1);
    r=rand(n,1)>p;
    x(r)=normrnd(0,1,sum(r),1);    
    x(~r)=normrnd(3,3,n-sum(r),1);
    medi=[medi;median(x)];
    mea=[mea;mean(x)];
    midhinge=[midhinge;(quantile(x,0.25)+quantile(x,0.75))/2];    
    temp1=quantile(x,0.25);
    temp2=quantile(x,0.75);
    xprime=x(x>temp1 & x<temp2);
    iqm=[iqm;mean(xprime)];

    
end
X=[medi,mea,midhinge,iqm];
figure(3), clf;
boxplot(X)
return

subplot(2,2,1)
%boxplot(mea,'orientation','horizontal')
boxplot(mea);
title('Mean')
subplot(2,2,2)
%boxplot(medi,'orientation','horizontal')
boxplot(medi);
title('Median')
subplot(2,2,3)
%boxplot(midhinge,'orientation','horizontal')
boxplot(midhinge);
title('Midhinge')
subplot(2,2,4)
%boxplot(iqm,'orientation','horizontal')
boxplot(iqm);
title('IQM')